#include "ball.h"
#include "defines.h"

#include <stdio.h>

//BALL
Ball::Ball()
{
	x=0; y=0;
	dx=0; dy=0;
}

void Ball::Update()
{
	char buffer[80];
	x+=m_dx;
	y+=m_dy;
	sprintf(buffer, "(%d, %d) -> (%d, %d)", x, y, dx, dy);
	Draw_Text_GDI(buffer,0,0,255);

	// border collision?
	if( x<ContainerRect.left || (x+BALL_SIZE)>ContainerRect.right )
	{
		dx=-dx;
		x+=dx;
	}
	if( y<ContainerRect.top || (y+BALL_SIZE)>ContainerRect.bottom )
	{
		dy=-dy;
		y+=dy;
	}
}

void Ball::Test(Ball* ball)
{
	return;
	int dx = ball->x - x;
	int dy = ball->y - y;
	if( (dy*dy+dx*dx)<BALL_SIZE*BALL_SIZE )
	{
		dx=-dx;
		dy=-dy;
		ball->dx=-ball->dx;
		ball->dy=-ball->dy;
	}
}

void Ball::Draw()
{
	Draw_Rectangle(x, y, x+BALL_SIZE, y+BALL_SIZE, 255);
}

//BALLS
Balls::Balls(int n)
{
	if(n>0)	balls = new Ball[n];
	else balls = 0;
	count=n;
}

Balls::~Balls()
{	if(balls) delete balls;	}

void Balls::Resize(int n, bool preserve)
{
	Ball* newballs;
	newballs = new Ball[n];
	if(balls)
	{
		if(preserve)
			for(int i=0; i<MIN(n,count); i++)
				newballs[i]=balls[i];
		delete []balls;
	}
	balls=newballs;
}

void Balls::Update()
{
	for(int i=0; i<count; i++)
	{
		balls[i].Update();
		for(int j=i+1; j<count; j++)
			balls[i].Test(&balls[j]);
	}
}

void Balls::Draw()
{
	for(int i=0; i<count; i++)
		balls[i].Draw();
}

Ball* Balls::GetBall(int i)
{
	if(i<0 || i>=count) return NULL;
	else return &balls[i];
}